#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

enum tag {Single, Pair};

struct LispEl
{
  tag Tag;
  union
  {
    char Leaf; //.
    struct     // .
    {
       LispEl* Left;
       LispEl* Right;
     } Pr;
  };
};

class Tree
{
  private:
    LispEl* Root; //   .
  public:
    void PrintTree (LispEl*, int);
    void Enter (LispEl**, int&, char *);
    LispEl** GetTree() { return &Root; };
    LispEl* GetTree1() { return Root; };
    Tree () { Root = NULL; };
};

// ------------    ----------
void Tree::PrintTree (LispEl* W, int l)
// p p,   p W.
{
  int i;

  if  (W->Tag!=Single)
  {
     PrintTree (W->Pr.Right,l+1);
     for (i=1;i<=l;i++) cout << "   "; 
     cout << "#\n";
     PrintTree (W->Pr.Left,l+1);
  }
  else 
  {
     for (i=1;i<=l;i++) cout << "   "; 
     cout << W->Leaf << endl;
  }
}

void Tree::Enter (LispEl** T, int& i, char *Str)
//p p p,
// S-p  LISP.
{
  char X;

  cout << " "; X = Str[i]; i++;
  //   p X  p p.
  if (X=='#')
  {
   (*T) = new (LispEl);
   (**T).Tag = Pair;
   Enter (&((*T)->Pr.Left),i,Str);
   Enter (&((*T)->Pr.Right),i,Str);
  }
  else
  {
   (*T) = new (LispEl);
   (**T).Tag = Single; (*T)->Leaf = X;
  }
}

// ---------------  LISP --------------
LispEl* MAKEATOM (char C)
{

  LispEl* h = new (LispEl);
  h->Tag = Single; 
  h->Leaf = C;
  return h;
}

LispEl* CONS (LispEl* X,LispEl* Y)
//p S-p   S-p X  Y.
{
  LispEl* p = new (LispEl);

  p->Tag = Pair; p->Pr.Left = X; p->Pr.Right = Y;
  return p;
}

int ATOM (LispEl* X)
//pp  p.
{
  return (X->Tag == Single);
}

LispEl* CAR (LispEl* X)
// p  S-p.
{
  return X->Pr.Left;
}

LispEl* CDR (LispEl* X)
// p  S-p.
{
  return X->Pr.Right;
}

int EQ (LispEl* X, LispEl* Y)
//pp p  p S-p.
{
  return (X->Leaf == Y->Leaf);
}

char VAL (LispEl* A)
{
  return A->Leaf;
}

char FIRSTATOM (LispEl* X)
//p p  S-p.
{
  if (ATOM (X)) return X->Leaf;
  else  FIRSTATOM (CAR (X));
}

int EQUAL (LispEl* X, LispEl* Y)
//pp  p S-p X  Y.
{
  if  (ATOM (X) || ATOM (Y))
  {
    if  (ATOM (X) && ATOM (Y)) return EQ (X,Y);
    else  return 0;
  }
  else
  {
    if  (EQUAL (CAR (X),CAR (Y))) return EQUAL (CDR (X),CDR (Y));
    else  return 0;
  }
}

// ------------   -------------
void Convert (char *Str, char (*Result)[])
{
  char Ch[2]; // .

  Ch[1]='\0'; strcpy(*Result,"");
  for (int k=0;k<strlen(Str);k++)
  {
   Ch[0] = Str[k];
   if  (Ch[0]=='(') strcat((*Result),"#");
   else
    if  (Ch[0]!=')' && Ch[0]!='.' && Ch[0]!=' ')
       strcat ((*Result),Ch);
  }
}


void main()
{
  char Str[23];    //p  p p.
  char Result[23]; //p   p.
  Tree A,B;
  int i=0;         // p.

  cout << "p  p p  p \n";
  cout << "  p...\n";
  A.PrintTree (CONS (CONS (MAKEATOM('A'),MAKEATOM('B')),
                 CONS (MAKEATOM('C'),MAKEATOM('D'))),0);
  cout << endl;
  cout << " ------------------------------------ " << endl;
  getch();
  B.PrintTree (CONS (MAKEATOM('A'),
                 CONS (MAKEATOM ('B'),
                   CONS (MAKEATOM('C'),
                     MAKEATOM('D')))) ,0);
  cout << " ------------------------------------ " << endl;
  getch();

  Tree C,D;

  cout << "p p p  p \n";
  cout << "    p...\n";
  cout << " p  p... \n";
  gets (Str);
  Convert(Str,&Result);
  strcpy(Str,Result);
  C.Enter (C.GetTree(),i,Str);
  cout << endl;
  C.PrintTree (C.GetTree1(),0);
  cout << "\n ---------------------------------------- \n";
  getch();
  cout << " p  p...\n";
  i = 0; gets (Str);
  Convert(Str,&Result); strcpy(Str,Result);
  D.Enter (D.GetTree(),i,Str);
  cout << endl;
  D.PrintTree (D.GetTree1(),0);
  cout << "\n ---------------------------------------- \n";
  getch();
  cout << "p   CONS...\n";
  Tree E;
  cout << endl;
  E.PrintTree (CONS (C.GetTree1(),D.GetTree1()),0);
  cout << "\n ---------------------------------------- \n";
  cout << "p   ATOM,CAR,CDR...\n";
  Tree F;
  if  (ATOM (C.GetTree1()))
	  F.PrintTree (CAR (CONS (C.GetTree1(),D.GetTree1())),0);
  else  F.PrintTree (CDR (CONS (C.GetTree1(),D.GetTree1())),0);
  cout << "\n ---------------------------------------- \n";
  getch();
  cout <<"p   EQUAL...\n";
  if  (EQUAL (C.GetTree1(),D.GetTree1()))
	  cout << "S-p p...\n";
  else  cout << "S-p  p...\n";
  cout << " ---------------------------------------- \n";
  getch();
  cout << "p   EQ...\n";
  if  (ATOM (C.GetTree1()) && ATOM (D.GetTree1()) &&
			 EQ (C.GetTree1(),D.GetTree1()))
	 cout << " p...\n";
  else  cout << "  p...\n";
  cout << " ---------------------------------------- \n";
  cout << "p   \"\" ...\n";
  cout << FIRSTATOM (CONS (C.GetTree1(),D.GetTree1()));
  cout << "\n ---------------------------------------- \n";
  getch();
  cout << "p   VAL...\n";
  if  (ATOM (C.GetTree1()))
	 cout << VAL (C.GetTree1());
  else cout << " VAL p   ...\n";
}
